new Vue({
    el: "#home",
    name: 'home',
    data() {
        return {
            showLoginAccount: false,
            showAccountInfo: false,
            showPayConfim: false,
            username: '',
            password: '',
            diamondList: [],
            roomCardList: [],
            otherList: [],
            tabIndex: 'roomCard',
            choseGoodsIndex: 0,
            buy_count: 0,
            is_received: 0,
            ybuy_count: 0,
            userid: '',
            nick: '',
            imgurl: '',
            payurl: '',
            wxopenid: '',
            wxpubconfig: '',
            appid: '',
            payAmount: 0,
            payPrice: 0,
            goodsType: "房卡",
            receiveCardColor: 'gray',
            payObj: {},
            boxStyle: {},
            showOther: false,
            showHistoryAccount: false,
            historyAccountList: []
        }
    },
    created() {
        if (is_wexin()) {
            this.init()
        }
        var isPageHide = false;
        window.addEventListener('pageshow', function () {
            if (isPageHide) {
                window.location.reload();
            }
        });
        window.addEventListener('pagehide', function () {
            isPageHide = true;
        });

    },
    mounted() {
        let screenHeight = $('.home-box').height()
        let bottomTop = $('.home-pay-btn').offset().top
        this.boxStyle = {
            'padding-bottom': (screenHeight - bottomTop + 30) + 'px'
        }
        if (sessionStorage.getItem('logintype') != null) {
            this.showOther = true
        } else {
            this.showOther = false
        }
        if (localStorage.getItem('history')) {
            this.historyAccountList = JSON.parse(localStorage.getItem('history'))
        }
    },
    methods: {
        init() {
            this.userid = localStorage.getItem('userid')
            this.nick = localStorage.getItem("nick")
            this.imgurl = localStorage.getItem("imgurl")
            if (this.imgurl) {
                this.imgurl = this.imgurl.replace('xinyueyouxi', 'xinyuesite')
            }
            if (this.userid) {
                if (localStorage.getItem('orderid')) {
                    vant.Dialog.alert({
                            title: '温馨提示',
                            message: '如您已完成支付,请到游戏客户端查收～'
                        })
                        .then(() => {
                            localStorage.removeItem('orderid')
                        })
                } else {
                    this.showAccountInfo = true
                }
                this.getShopList()
                this.getCardTotal()
            } else {
                vant.Dialog.alert({
                        title: '温馨提示',
                        message: '您还没有登录，请点击返回登录页面～',
                        confirmButtonText: '返回登录页面',
                    })
                    .then(() => {
                        window.location.href = 'login.html'
                    })
            }
        },
        changeTab(val) {
            this.tabIndex = val
            this.choseGoodsIndex = 0

            if (val == 'roomCard') {
                this.payAmount = this.roomCardList[0].amount
                this.payPrice = this.roomCardList[0].price / 100
                this.payObj = this.roomCardList[0]
                this.goodsType = '房卡'
            } else if (val == 'diamond') {
                this.payAmount = this.diamondList[0].amount
                this.payPrice = this.diamondList[0].price / 100
                this.payObj = this.diamondList[0]
                this.goodsType = '钻石'
            } else if (val == 'other') {
                this.payAmount = this.otherList[0].amount
                this.payPrice = this.otherList[0].price / 100
                this.payObj = this.otherList[0]
                this.goodsType = '其他'
            }
        },
        receiveCard() {
            let that = this;
            let url = 'https://xapi2.xinyuesite.com/new_shop/receivecard'
            let params = {
                userid: parseInt(this.userid),
                num: parseInt(this.ybuy_count),
                form_type: "wehcat"
            }
            if (this.is_received == 0) {
                vant.Toast("您没有可领取的赠卡！");
            } else {
                request(url, base64Params(params), "post", function (res) {
                    if (res.status == 0) {
                        vant.Toast("已领取到背包！");
                        that.getCardTotal()
                    } else {
                        vant.Toast(res.msg);
                    }

                })
            }
        },
        showAccountLogin() {
            localStorage.removeItem('orderid')
            this.showAccountInfo = false
            this.showLoginAccount = true
        },
        closeLogin() {
            this.showLoginAccount = false
            this.username = ""
            this.password = ""
            this.$refs['loginForm'].resetValidation()
            this.showHistoryAccount = false
        },
        choseAccount(obj) {
            this.showHistoryAccount = false
            this.onSubmit(obj)
        },
        delHistoryAccount(obj, i) {
            this.historyAccountList.splice(i, 1)
            localStorage.setItem("history", JSON.stringify(this.historyAccountList))
            if (this.historyAccountList.length == 0) {
                this.showHistoryAccount = false
            }
        },
        saveHistoryAccount(obj) {
            let list = this.historyAccountList
            let flag = true;
            for (let i = 0; i < this.historyAccountList.length; i++) {
                if (obj.username == this.historyAccountList[i].username) {
                    flag = false
                }
            }
            if (list.length == 0 || flag) {
                list.push(obj)
            }
            localStorage.setItem("history", JSON.stringify(list))
        },
        usernameFocus() {
            if (localStorage.getItem('history') && this.historyAccountList.length) {
                this.historyAccountList = JSON.parse(localStorage.getItem('history'))
                this.showHistoryAccount = true
            }
        },
        showHistoryDiv() {
            if (localStorage.getItem('history')) {
                this.historyAccountList = JSON.parse(localStorage.getItem('history'))
            }
            this.showHistoryAccount = !this.showHistoryAccount
        },
        usernameInput(val) {
            if (val) {
                this.showHistoryAccount = false
            }
        },
        onSubmit(values) {
            let that = this
            if (values) {
                let b = Base64.encode(values.password)
                b = b.split('').reverse().join('')
                b = Base64.encode(b)
                let params = {
                    password: b,
                    username: values.username
                }
                request('http://shop-mp.xinyuesite.com/shop/login', params, "post", function (res) {
                    if (res.code == 0) {
                        let imgurl = res.data.data.imgurl.replace('xinyueyouxi', 'xinyuesite')
                        localStorage.setItem("userid", res.data.data.userID)
                        localStorage.setItem("nick", res.data.data.nick)
                        localStorage.setItem("imgurl", imgurl)
                        sessionStorage.setItem('logintype', 1)
                        that.saveHistoryAccount(values)
                        that.showOther = true
                        that.resetData()
                        that.closeLogin()
                        that.init()
                    } else {
                        vant.Toast(res.msg);
                    }
                })
            }
        },
        loginWx() {
            localStorage.removeItem("userid")
            localStorage.removeItem("nick")
            localStorage.removeItem("imgurl")
            sessionStorage.clear()
            window.location.href = 'login.html'
        },
        resetData() {
            this.choseGoodsIndex = 0
            this.tabIndex = 'roomCard'
            this.changeTab('roomCard')
        },
        pay() {
            this.showPayConfim = true
        },
        closePopup() {
            this.showPayConfim = false
            this.showAccountInfo = false
        },
        wechatPay() {
            // let buyMoney = (this.buy_count / 5) + (this.payAmount / 5)
            // if (buyMoney > 50 && this.goodsType == '房卡') {
            //     vant.Toast('每月房卡充值金额限额500元。', 3);
            //     return
            // }
            let params = {
                "type": "wechatH5",
                "goods": this.payObj.tag,
                "money": parseInt(this.payObj.price),
                "userid": parseInt(this.userid),
                "subject": this.goodsType,
                "body": this.payObj.name,
                "roomid": 0,
                "ingame": 0,
                "pay_stage": 1,
                "autobuy": 1,
                "ext": {
                    "ico": "hall_prop_icon/img_prop_roomcard.png"
                },
                "new_h5": 1,
                "ispch5": 1,
                "is_wechatpub": 1,
                "debug": 0,
                "roomtype": 0,
                "virtual": 0,
                "udid": "1111111111111111111111111111111111111111"
            }
            let url = 'https://xpay1.xinyuesite.com/order/new/2/900/1.0.184/220101'
            request(url, params, "post", function (res) {
                if (res.status == 200) {
                    let result = res.responseText
                    result = result.replace('return', '').replace('{', "").replace('}', '')
                    let payurl = ''
                    let status = ''
                    let msg = ''
                    let orderid = ''
                    let tArr = result.split(',')
                    for (let i = 0; i < tArr.length; i++) {
                        if (tArr[i].indexOf('callbackurl=') !== -1) {
                            payurl = tArr[i]
                        }
                        if (tArr[i].indexOf('status=') !== -1) {
                            status = tArr[i].split('=')[1]
                        }
                        if (tArr[i].indexOf('msg=') !== -1) {
                            msg = tArr[i].replace('msg="', "").replace('"', "")
                        }
                        if (tArr[i].indexOf('orderid=') !== -1) {
                            orderid = tArr[i].replace('orderid="', "").replaceAll('"', "")
                        }
                    }
                    if (status == 0) {
                        payurl = payurl.replace('callbackurl="', "").replace('"', "")
                        localStorage.setItem('orderid', orderid)
                        window.location.href = payurl
                    } else {
                        vant.Toast(msg);
                    }
                }
            })
        },
        choseGoods(item, type, index) {
            switch (type) {
                case 1:
                    this.goodsType = '房卡'
                    break;
                case 2:
                    this.goodsType = '钻石'
                    break;
                case 3:
                    this.goodsType = '其他'
                    break;
                default:
                    break;
            }
            this.payAmount = item.amount
            this.payPrice = item.price / 100
            this.choseGoodsIndex = index
            this.payObj = item
        },
        getShopList() {
            let that = this
            let url = 'http://shop-mp.xinyuesite.com/shop/list'
            request(url, {}, "post", function (res) {
                if (res.code == 0) {
                    if (res.data) {
                        that.diamondList = res.data.diamond || []
                        that.roomCardList = res.data.room_card || []
                        that.otherList = res.data.other || []
                        if (that.roomCardList.length) {
                            that.payAmount = that.roomCardList[0].amount
                            that.payPrice = that.roomCardList[0].price / 100
                            that.payObj = that.roomCardList[0]
                        }
                    }
                } else {
                    vant.Toast(res.msg);
                }
            })
        },
        getCardTotal() {
            let that = this;
            let url = 'https://xapi2.xinyuesite.com/new_shop/cardtot'
            let params = {
                'userid': parseInt(that.userid)
            }
            request(url, base64Params(params), "post", function (res) {
                if (res.status == 0) {
                    let obj = JSON.parse(base64Result(res.data))
                    console.log(obj)
                    that.buy_count = obj.buy_count
                    that.is_received = obj.is_received
                    if (obj.is_received == 1) {
                        that.receiveCardColor = "#f2892e"
                    }
                    that.ybuy_count = obj.ybuy_count
                } else {
                    vant.Toast(res.msg);
                }

            })
        }
    }
})

Vue.use(vant.Lazyload);