new Vue({
    el: "#login",
    name: 'login',
    data() {
        return {
            username: '',
            password: '',
            showLoginAccount: false,
            wxLoginError: false
        }
    },
    mounted() {
        if (is_wexin()) {
            this.getWxCode()
        }
    },
    methods: {
        showAccountLogin() {
            this.showLoginAccount = true
        },
        closeLogin() {
            this.showLoginAccount = false
            this.username = ""
            this.password = ""
            this.$refs['loginForm'].resetValidation()
        },
        onSubmit(values) {
            let that = this
            if (values) {
                let b = Base64.encode(values.password)
                b = b.split('').reverse().join('')
                b = Base64.encode(b)
                let params = {
                    password: b,
                    username: values.username
                }
                request('http://shop-mp.xinyuesite.com/shop/login', params, "post", function (res) {
                    console.log(res)
                    if (res.code == 0) {
                        let imgurl = res.data.data.imgurl.replace('xinyueyouxi', 'xinyuesite')
                        localStorage.setItem("userid", res.data.data.userID)
                        localStorage.setItem("nick", res.data.data.nick)
                        localStorage.setItem("imgurl", imgurl)
                        sessionStorage.setItem('logintype', 1)
                        that.closeLogin()
                        window.location.href = 'home.html'
                    } else {
                        vant.Toast(res.msg);
                    }
                })
            }
        },
        getWxCode() {
            if (!getQueryString("code")) {
                let url = "http://shop-mp.xinyuesite.com/sns/codeRedirect?url=" + encodeURIComponent(this.GetLocationURLWithoutCode()) + '&typ=userinfo'
                this.redirect(url)
                return
            } else {
                this.wxLogin()
            }
        },
        wxLogin() {
            let self = this
            let code = getQueryString("code")
            request('http://shop-mp.xinyuesite.com/h5/bind', {
                code: code,
                tag: 'qp',
                type: "new"
            }, "post", function (res) {
                if (res.code == 0) {
                    self.wxLoginError = false
                    let imgurl = res.data.data.imgurl.replace('xinyueyouxi', 'xinyuesite')
                    localStorage.setItem("userid", res.data.data.userID)
                    localStorage.setItem("nick", res.data.data.nick)
                    localStorage.setItem("imgurl", imgurl)
                    window.location.href = 'home.html'
                } else {
                    self.wxLoginError = true
                    vant.Dialog.confirm({
                            title: '提示！',
                            message: '微信授权失败，请刷新页面重试？',
                        })
                        .then(() => {
                            window.location.href = 'login.html'
                        })
                        .catch(() => {});
                }
            })
        },
        download() {
            window.location.href = 'https://www.xinyuepage.com/'
        },
        redirect(url) {
            if (url != "") {
                window.location.href = url
            }
        },
        GetLocationURLWithoutCode(params) {
            let protocol = window.location.protocol,
                host = window.location.host,
                path = window.location.pathname,
                query = window.location.search;
            let paramString = query.substring(1);
            let withoutCodeString = "";
            let vars = paramString.split("&");
            for (let i = 0; i < vars.length; i++) {
                if (vars[i] == "") {
                    continue
                }
                let pair = vars[i].split("=");
                if (pair[0] == "code" || pair[0] == "state" || pair[0] == "time" || pair[0] == "") {
                    continue
                }
                withoutCodeString += "&" + pair[0] + "=" + pair[1]
            }
            if (params) {
                withoutCodeString += '&time=' + params.time
            }
            if (withoutCodeString != "") {
                if (path.indexOf("?") != -1) {
                    withoutCodeString = "&" + withoutCodeString.substring(1)
                } else {
                    withoutCodeString = "?" + withoutCodeString.substring(1)
                }
            }
            return protocol + "//" + host + path + withoutCodeString
        }
    }
})

Vue.use(vant.Lazyload);